/**
 * Copyright (c) 2000-2005 Liferay, LLC. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.portlet.portletaggregatordesigner.action;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.PortletConfig;
import javax.portlet.PortletPreferences;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

import com.liferay.portal.model.Portlet;
import com.liferay.portal.service.spring.PortletServiceUtil;
import com.liferay.portlet.portletaggregatordesigner.util.LayoutTemplateParamKeys;
import com.liferay.portlet.portletaggregatordesigner.util.LayoutTemplatePrefKeys;
import com.liferay.util.PwdGenerator;

/**
 * <a href="AddPortletAction.java.html"><b><i>View Source</i></b></a>
 * 
 * @author Ivica Cardic
 * @version $Revision: 1.0 $
 * 
 */
public class AddPortletAction extends ViewAction {
	public void processAction(ActionMapping mapping, ActionForm form,
			PortletConfig config, ActionRequest req, ActionResponse res)
			throws Exception {
		PortletPreferences prefs = req.getPreferences();

		String columnId = req.getParameter(LayoutTemplateParamKeys.COLUMN_ID);
		String portletNamespace = req
				.getParameter(LayoutTemplateParamKeys.PORTLET_NAMESPACE);
		String portletId = req.getParameter("add_" + portletNamespace
				+ columnId + "_sel");
		String companyId = req.getParameter(LayoutTemplateParamKeys.COMPANY_ID);
		// String columnType =
		// req.getParameter(LayoutTemplateParamKeys.COLUMN_TYPE);

		String[] portletIds = prefs.getValues(columnId
				+ LayoutTemplatePrefKeys.PORTLETS, new String[0]);
		if (portletIds == null) {
			portletIds = new String[0];
		}

		// Refresh button of browser
		for (int i = 0; i < portletIds.length; i++) {
			if (portletIds[i].equals(portletId)) {
				return;
			}
		}

		String[] tempPortletIds = portletIds;
		portletIds = new String[portletIds.length + 1];
		System.arraycopy(tempPortletIds, 0, portletIds, 0,
				tempPortletIds.length);

		Portlet portlet = PortletServiceUtil.getPortletById(companyId,
				portletId);
		if (portlet.isInstanceable()) {
			portletId += Portlet.INSTANCE_SEPARATOR
					+ PwdGenerator.getPassword(4);
		}
		portletIds[portletIds.length - 1] = portletId;

		// prefs.setValue(columnId+"-type",columnType);
		prefs.setValues(columnId + LayoutTemplatePrefKeys.PORTLETS, portletIds);
		prefs.store();
	}
}
