/**
 * Copyright (c) 2000-2005 Liferay, LLC. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.portlet.portletaggregatordesigner.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.PageContext;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.liferay.portal.model.Layout;
import com.liferay.portal.util.Constants;
import com.liferay.portal.util.WebKeys;
import com.liferay.portlet.portletaggregatordesigner.util.LayoutTemplateParamKeys;
import com.liferay.portlet.portletaggregatordesigner.util.LayoutTemplateUtil;
import com.liferay.util.BrowserSniffer;
import com.liferay.util.ParamUtil;

/**
 * <a href="MovePortletUpAction.java.html"><b><i>View Source</i></b></a>
 * 
 * @author Ivica Cardic
 * @version $Revision: 1.0 $
 * 
 */
public class MovePortletUpAction extends Action {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest req, HttpServletResponse res) throws Exception {

		try {
			Layout layout = (Layout) req.getAttribute(WebKeys.LAYOUT);

			boolean refreshPage = BrowserSniffer.is_ns_4(req);

			String portletId = ParamUtil.getString(req,
					LayoutTemplateParamKeys.P_P_ID);

			String columnId = ParamUtil.getString(req,
					LayoutTemplateParamKeys.P_P_COLUMN_ID);

			String portletAggregatorId = ParamUtil.getString(req,
					LayoutTemplateParamKeys.P_P_PORTLET_AGGREGATOR_ID);

			LayoutTemplateUtil.movePortletUp(req, layout, portletAggregatorId,
					columnId, portletId);

			if (!refreshPage) {
				return mapping.findForward(Constants.COMMON_NULL);
			} else {
				return mapping.findForward(Constants.COMMON_REFERER);
			}
		} catch (Exception e) {
			req.setAttribute(PageContext.EXCEPTION, e);

			return mapping.findForward(Constants.COMMON_ERROR);
		}
	}

}