/**
 * Copyright (c) 2000-2005 Liferay, LLC. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.portlet.portletaggregatordesigner.service.spring;

import java.rmi.RemoteException;

import com.liferay.portal.SystemException;
import com.liferay.portlet.portletaggregatordesigner.model.LayoutTemplate;

/**
 * <a href="LayoutTemplateService.java.html"><b><i>View Source</i></b></a>
 * 
 * @author Ivica Cardic
 * @version $Revision: 1.0 $
 * 
 */
public interface LayoutTemplateService {
	public LayoutTemplate getLayoutTemplate(java.lang.String layoutId)
			throws com.liferay.portal.SystemException, RemoteException;

	public String getLayoutTemplatePath(String layoutTemplateId)
			throws SystemException, RemoteException;

	public String getLayoutTemplateContent(String layoutTemplateId)
			throws com.liferay.portal.SystemException, RemoteException;

	public void setLayoutTemplateContent(String layoutTemplateId, String content)
			throws com.liferay.portal.SystemException, RemoteException;

	public java.util.List getLayoutTemplates()throws java.rmi.RemoteException;

	public java.util.List init(java.lang.String[] templates)
			throws RemoteException;

	public java.util.List init(java.lang.String servletContextName,
			java.lang.String[] templates) throws RemoteException;

	public void uninstallLayoutTemplate(java.lang.String templateId)
			throws RemoteException;
}
