/**
 * Copyright (c) 2000-2005 Liferay, LLC. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.portlet.portletaggregatordesigner.service.spring;

import java.util.List;

import com.liferay.portlet.portletaggregatordesigner.model.LayoutTemplate;

/**
 * <a href="LayoutTemplateServiceUtil.java.html"><b><i>View Source</i></b></a>
 * 
 * @author Ivica Cardic
 * @version $Revision: 1.0 $
 * 
 */
public class LayoutTemplateServiceUtil {
	public static LayoutTemplate getLayoutTemplate(
			java.lang.String layoutTemplateId)
			throws com.liferay.portal.SystemException {
		try {
			LayoutTemplateService layoutTemplateService = LayoutTemplateServiceFactory
					.getService();

			return layoutTemplateService.getLayoutTemplate(layoutTemplateId);
		} catch (com.liferay.portal.SystemException se) {
			throw se;
		} catch (Exception e) {
			throw new com.liferay.portal.SystemException(e);
		}
	}

	public static String getLayoutTemplatePath(java.lang.String layoutTemplateId)
			throws com.liferay.portal.SystemException {
		try {
			LayoutTemplateService layoutTemplateService = LayoutTemplateServiceFactory
					.getService();

			return layoutTemplateService
					.getLayoutTemplatePath(layoutTemplateId);
		} catch (com.liferay.portal.SystemException se) {
			throw se;
		} catch (Exception e) {
			throw new com.liferay.portal.SystemException(e);
		}
	}

	public static String getLayoutTemplateContent(
			java.lang.String layoutTemplateId)
			throws com.liferay.portal.SystemException {
		try {
			LayoutTemplateService layoutTemplateService = LayoutTemplateServiceFactory
					.getService();

			return layoutTemplateService
					.getLayoutTemplateContent(layoutTemplateId);
		} catch (com.liferay.portal.SystemException se) {
			throw se;
		} catch (Exception e) {
			throw new com.liferay.portal.SystemException(e);
		}
	}

	public static void setLayoutTemplateContent(java.lang.String layoutTemplateId,
			String content) throws com.liferay.portal.SystemException {
		try {
			LayoutTemplateService layoutTemplateService = LayoutTemplateServiceFactory
					.getService();

			layoutTemplateService
					.setLayoutTemplateContent(layoutTemplateId,content);
		} catch (com.liferay.portal.SystemException se) {
			throw se;
		} catch (Exception e) {
			throw new com.liferay.portal.SystemException(e);
		}
	}

	public static java.util.List getLayoutTemplates()
			throws com.liferay.portal.SystemException {
		try {
			LayoutTemplateService layoutTemplatesService = LayoutTemplateServiceFactory
					.getService();

			return layoutTemplatesService.getLayoutTemplates();
		} catch (Exception e) {
			throw new com.liferay.portal.SystemException(e);
		}
	}

	public static java.util.List init(java.lang.String[] xmls)
			throws com.liferay.portal.SystemException {
		try {
			LayoutTemplateService layoutTemplatesService = LayoutTemplateServiceFactory
					.getService();

			return layoutTemplatesService.init(xmls);
		} catch (Exception e) {
			throw new com.liferay.portal.SystemException(e);
		}
	}

	public static java.util.List init(String servletContextName,
			java.lang.String[] xmls) throws com.liferay.portal.SystemException {

		List layoutTemplateIds;
		try {
			LayoutTemplateService layoutTemplatesService = LayoutTemplateServiceFactory
					.getService();

			layoutTemplateIds = layoutTemplatesService.init(servletContextName,
					xmls);
		} catch (Exception e) {
			throw new com.liferay.portal.SystemException(e);
		}
		return layoutTemplateIds;
	}

	public static void uninstallLayoutTemplate(java.lang.String layoutTemplateId)
			throws com.liferay.portal.SystemException {
		try {
			LayoutTemplateService layTempService = LayoutTemplateServiceFactory
					.getService();
			layTempService.uninstallLayoutTemplate(layoutTemplateId);
		} catch (Exception e) {
			throw new com.liferay.portal.SystemException(e);
		}
	}
}
